const { REST } = require('@discordjs/rest');
const { Routes } = require('discord-api-types/v10');
const Discord = require('discord.js');
const { send, userSend, bdfnEmbed } = require('../utils/Messages');
const ms = require('ms');
const os = require('os');

module.exports = {

    create: async (name = String, Options = {
        type: String,
        slashCommand: { is: false, builder: Object },
        alias: Array
    }, callback) => {
        if(!Options.type && Options.type != 'GUILD_PRIVATE_SLASH' && Options.type != 'GUILD_PUBLIC_SLASH' && Options.type != 'MD' && Options.type != 'GUILD_MESSAGE') throw new Error('You must to type the command type. Options: MD, GUILD_PRIVATE_SLASH, GUILD_PUBLIC, GUILD_MESSAGE');
        if(!Discord._client.cmds) Discord._client.cmds = new Map();

        Discord._client.cmds.set(name, {
            Options: Options,
            callback: callback,
            slashCommand: { is: Options.slashCommand.is? true : false, builder: Options.slashCommand.builder },
            parent: true
        });
        
        if(Options.alias) for(alias of Options.alias) {
            Discord._client.cmds.set(alias, {
                Options: Options,
                callback: callback,
                slashCommand: { is: Options.slashCommand.is? true : false, builder: Options.slashCommand.builder },
                parent: name
            });
        }
    },

    delete: async (name) => {
        Discord._client.cmds.delete(name);
    },

    has: async (name) => {
        if(Discord._client.cmds.has(name)) return true;
        else return false;
    },

    use: async (commandName = String, args = Array, event = Object) => {
        if(!commandName) throw new Error('You must to type the command name to use any command.');

        if(!Discord._client.cmds) Discord._client.cmds = new Map();
        commandName = await Discord._client.cmds.get(commandName);

        event.messages = {
            send, userSend, bdfnEmbed
        };
        event.args = args;
        event.ping = (editedMessageParam) => {
            return `${ ms(editedMessageParam.createdTimestamp - event.createdTimestamp) }`;
        };
        event.memory = () => {
            return `${ parseFloat((process.memoryUsage().heapUsed / Math.pow(1024, Math.floor(Math.log(process.memoryUsage().heapUsed) / Math.log(1024)))).toFixed(2)) + "" + ['B', 'KB', 'MB', 'GB', 'TB'][Math.floor(Math.log(process.memoryUsage().heapUsed) / Math.log(1024))] }`;
        };
        event.uptime = () => {
            return `${ ms(os.uptime() * 1000) }`;
        };

        if(commandName.Options.type === 'GUILD_MESSAGE') {
            commandName.callback(event);
        }else if(commandName.Options.type === 'GUILD_PRIVATE_SLASH' || commandName.Options.type === 'GUILD_PUBLIC_SLASH') {
            commandName.callback(event);
        }else if(commandName.Options.type === 'MD') {
            commandName.callback(event);
        }
    },

    slash: {
        privateShoot: async (ignoreGuilds = []) => {
            let SlashCommands = Array.from(Discord._client.cmds.values()).filter(Slash => Slash.slashCommand.is != false);
            let rest = new REST({ version: '10' }).setToken(`${Discord._client.token}`);

            for(var guild of Discord._client.guilds.cache) {
                if(!ignoreGuilds.includes(guild.id)) {
                    try{ await rest.put(Routes.applicationGuildCommands(Discord._client.user.id, guild.id), { body: SlashCommands.filter(Slash => Slash.slashCommand.Options.type != 'GUILD_PUBLIC_SLASH').map(Builder => Builder.slashCommand.builder) }); }catch(err) {}
                }
            }
        },
        globalShoot: async () => {
            let SlashCommands = Array.from(Discord._client.cmds.values()).filter(Slash => Slash.slashCommand.is != false);    
            await client.application.commands.set(SlashCommands.filter(Slash => Slash.slashCommand.Options.type != 'GUILD_PRIVATE_SLASH').map(Builder => Builder.slashCommand.builder));
        }
    }
};