const { getArgs, getCommand } = require('../utils/Args');
const { use, has } = require('../cmds/base');
const dbBase = require('../db/base');
const db = new dbBase.model('maps');
db.createModel('cooldowns', { lastPost: Number });

module.exports = {
    basicCmdFilterExtension: async (message, prefix) => {
        if(!message.content.startsWith(prefix))return;

        let args = await getArgs(message.content, prefix);
        let command = await getCommand(args);
    
        if(await has(command)) {
            use(command, args, message);
            return { found: true, args: args, command: command };
        }else return { found: false, args: args, command: command };
    },

    basicCmdFilterExtensionWithCooldown: async (message, prefix, msCooldown) => {
        if(!message.content.startsWith(prefix))return;
        
        let args = await getArgs(message.content, prefix);
        let command = await getCommand(args);
        
        if(await has(command)) {
            if(!await db.has(message.author.id)) db.set(message.author.id, { lastPost: Date.now() });
            else {
                message.author.cache = await db.get(message.author.id);
                if(message.author.cache.lastPost + msCooldown < Date.now())return { cmdFound: true, cmdEmitted: false, args: args, command: command };
            };
            use(command, args, message);
            return { cmdFound: true, cmdEmitted: true, args: args, command: command };
        }else return { cmdFound: false, cmdEmitted: false, args: args, command: command };
    }
}